<?php 
require('../inc/config.php');
require('../inc/config.settings.php');
require('../inc/config.mimetypes.php');
require('../inc/common.php');
require('../inc/init.php');
require('../inc/header.php');
require('../inc/cookie.php');
require('../inc/global.php');
require('../inc/smarty.php');
require('../inc/lib.php');
require('../inc/class.ftpfolder.php');
require('../inc/class.ftpshare.php');

$selected_theme = 'share';

$mailuser_dbfile_bak=$mailuser_dbfile;
if (isset($f)) {
	$f = str_replace(' ', '+', $f);
	$f = base64_decode($f);

	parse_str($f, $urlpara);
	extract($urlpara, EXTR_SKIP);
}
$mailuser_dbfile=$mailuser_dbfile_bak;

$userid = trim($userid);
$iPos = strpos($userid, '@');
if ($iPos !== false)
	$domain = substr($userid, $iPos+1);
else
	$domain = '';

$advfile = $customizepath.$domain.'_main_logo.gif';
if (!file_exists($advfile))
	$advfile = $customizepath.'main_logo.gif';
if (file_exists($advfile))
	$smarty->assign('MainLogo', $advfile);
else
	$smarty->assign('MainLogo', '');
	
if ($userid == ''){
	$smarty->assign('errCode', 1);
	$smarty->display($selected_theme.'/netdisk-viewshare.htm');
	exit;
}

getlanguagetext($selected_common_language, 'NetDisk');

$domaininfo = load_domaininfo($domain);
$userinfo = load_userinfo($userid);

if ($domaininfo == false || $userinfo == false){
	$smarty->assign('errCode', 1);
	$smarty->display($selected_theme.'/netdisk-viewshare.htm');
	exit;
}

if ($userinfo['netdiskcontrol'] != 1){
	$smarty->assign('errCode', 1);
	$smarty->display($selected_theme.'/netdisk-viewshare.htm');
	exit;
}

$homedirectory = getmailhomedirectory($userid, $userinfo['mailstorepath'], $domaininfo['mailstorepath'], $mailstore_directory);
if (substr($homedirectory, -1) != '\\')
	$homedirectory .= '\\';

$ftphomedirectory = getmailhomedirectory($userid, $userinfo['ftpstorepath'], $domaininfo['ftpstorepath'], $ftpstore_directory);
if (substr($ftphomedirectory, -1) != '\\')
	$ftphomedirectory .= '\\';

$session_value = array();
$session_value['homedirectory'] = $homedirectory;
$session_value['homedirectory_utf8'] = sys_encode_utf8($homedirectory);

$session_value['ftphomedirectory'] = $ftphomedirectory;

$nowtime = time();
if ($filename != '') {
	$filename = str_replace(' ', '+', $filename);
	$filename = base64_decode($filename);
}

if (substr($filename, 0, 2) == '..' || strpos($filename, ':') !== false) {
	$smarty->assign('errCode', 1);
	$smarty->display($selected_theme.'/netdisk-viewshare.htm');
	exit;
}
	

$bAttach = false;
if ($chksum != '') {
	if ($chksum != md5($userid.'|'.$filename.'|'.$start)) {
		$smarty->assign('errCode', 1);
		$smarty->display($selected_theme.'/netdisk-viewshare.htm');
		exit;
	}
	
	if ($nowtime - $start > $netdisk_share_expire) {
		$smarty->assign('errCode', 1);
		$smarty->display($selected_theme.'/netdisk-viewshare.htm');
		exit;
	}

	$bAttach = true;
}

if ($bAttach == false) {
	$ftp = new FtpShare($session_value['homedirectory']);
	$share = $ftp->GetShare();
	
	if (!empty($share['enddate']) && $nowtime > $share['enddate']){
		$smarty->assign('errCode', 1);
		$smarty->display($selected_theme.'/calendar-viewshare.htm');
		exit;
	}
	
	$share['password'] = Crypt_Decode($share['password']);
	if (!empty($share['user']) && !empty($share['password'])) {
		if (isset($_SERVER['HTTP_AUTHORIZATION'])) {
			list($_SERVER['PHP_AUTH_USER'], $_SERVER['PHP_AUTH_PW']) = explode(':', base64_decode(substr($_SERVER['HTTP_AUTHORIZATION'], 6)));
		}
	
		$realmname = convert($ftp_share_title, false);
		if (!isset($_SERVER['PHP_AUTH_USER']) || !isset($_SERVER['PHP_AUTH_PW'])) {
			header('WWW-Authenticate: Basic realm="'.$realmname.'"'); 
			header('HTTP/1.0 401 Unauthorized'); 
			echo 'Authorization Required !'; 
			exit; 
		} 
		
		$bAuthed = false; 
		if ($_SERVER['PHP_AUTH_USER'] == $share['user'] && $_SERVER['PHP_AUTH_PW'] == $share['password']) 
			$bAuthed = true; 
		
		if ($bAuthed == false) {
			header('WWW-Authenticate: Basic realm="'.$realmname.'"'); 
			header('HTTP/1.0 401 Unauthorized'); 
			echo 'Authorization Failure !'; 
			exit; 
		}
	}
}

$ftphandle = new FtpFolder;
$ftphandle->home_directory = $session_value['homedirectory'];
$ftphandle->ftp_home_directory = $session_value['ftphomedirectory'];
	
switch ($opt){
case 'view':
case 'download':
	$ftpfile = $filename;

	$iPos = strrpos($ftpfile, '/');
	if ($iPos !== false)
		$filename = substr($ftpfile, $iPos+1);
	else
		$filename = str_replace('/', '', $ftpfile);

	if(!file_exists($temporary_directory.'_attachments'))
		mkdir($temporary_directory.'_attachments');

	if ($opt == 'view'){
		$suffix = substr($filename, strrpos($filename, '.'));
		$suffix = strtolower($suffix);
		if (isset($mimetypes[$suffix]))
			$contenttype = $mimetypes[$suffix];
		else
			$contenttype = 'application/octet-stream';
		$disposition = 'inline';
	}
	else{
		$contenttype = 'application/force-download';
		$disposition = 'attachment';
	}
	
	$localfile = $ftphandle->ftp_home_directory.$ftpfile;
  	if (file_exists($localfile)) {
		$length = filesize($localfile);
		
   		header('Content-type: '.$contenttype);
	  	header('Content-Disposition: '.$disposition.'; filename="'.$filename.'"');
		header('Accept-Ranges: bytes');
		header('Content-Length: '.$length);

		$fp = fopen($localfile, "rb");
		if ($fp){
			while(!feof($fp))
				echo fread($fp, 655360);
				
			fclose($fp);
		}
    }
	else{
		$smarty->assign('errCode', 2);
		$smarty->display($selected_theme.'/netdisk-viewshare.htm');
	}
	break;
case 'sharelink':
default:
	if ($isdir != 1 && $filename != '') {
		$dispFileInfo = $ftphandle->get_folder_file($filename);
	}
	else {
		$dispdir = $filename.'/';

		$dispFileInfo = array();
		$ftp = new FtpShare($session_value['homedirectory']);
		$shareFtpFile = $ftp->GetAllShareFile();
		foreach ($shareFtpFile as $shareItem) {
			if (empty($shareItem['name']))
				continue;
			
			$fileInfo = $ftphandle->get_folder_file($shareItem['name']);
    		if ($fileInfo == false)
    			continue;
    			
    		foreach ($fileInfo as $item) {
				if (strpos($item['name'], $dispdir) === false)
					continue;
					
				$dispFileInfo[] = $item;
			}
    	}
    }
    
    $urlpara = 'userid='.$userid;
    $shareurl = 'viewsharenetdisk.php';

	$bRet = false;
	if (is_array($dispFileInfo)) {
		foreach ($dispFileInfo as $item) {
			$ftpfile = $item['name'];
    		unset($info);
    		
			$info['name'] = convert($ftpfile);
			$info['id'] = base64_encode($ftpfile);
			$linkpara = $urlpara.'&opt=download&filename='.$info['id'];
			$info['downlink'] = $shareurl.'?f='.base64_encode($linkpara);

			$iconname = $iconfile = '';
			$ipos = strrpos($info['name'], '.');
			if ($ipos !== false) {
				$iconname = substr($info['name'], $ipos+1);
				$iconname = strtolower($iconname);
	
				$iconfile = $fileiconpath.$iconname.'.gif';
			}
			
			if (empty($iconfile) || !file_exists($iconfile))
				$iconfile = $fileiconpath.'unknown.gif';
			
			$info['iconfile'] = $iconfile;
			if (isset($mimetypes['.'.$iconname])) {
				$linkpara = $urlpara.'&opt=view&filename='.$info['id'];
				$info['viewlink'] = $shareurl.'?f='.base64_encode($linkpara);
			}
			else {
				$info['viewlink'] = '';
			}
			
			$fsize = $item['size'];
			if ($fsize >= 1024*1024*1024)
				$filesize = sprintf('%.2f GB', round($fsize/(1024*1024*1024), 2));
			else if ($fsize >= 1024 * 1024)
				$filesize = sprintf('%.2f MB', round($fsize/(1024*1024), 2));
			else if ($fsize >= 1024)
				$filesize = sprintf('%.2f KB', round($fsize/1024), 2);
			else
				$filesize = sprintf('%d B', $fsize);
			$info['size'] = $filesize;
			
			$date = strftime($datetime_format, $item['date']);
			$info['date'] = convert($date);
			
			$dispList[] = $info;
			
			$bRet = true;
		}
		
	}
	if ($bRet) {
		array_sort($dispList, 'name', 'ASC_UTF8', 'time', 'DESC_UTF8');
		
		$smarty->assign('errCode', 0);
		$smarty->assign('FileList', $dispList);
		$smarty->assign('FileCount', count($dispList));
	}
	else {
		$smarty->assign('errCode', 3);
	}
	
	$smarty->assign('User', $userid);
	$smarty->display($selected_theme.'/netdisk-viewshare.htm');
	
	break;
}
?>