<?php
require('../../admin/inc/config.php');
require('../../inc/config.settings.php');
require('../../inc/common.php');
require('../../inc/class.session.php');
require('../../inc/header.php');
require('../../admin/inc/cookie.php');
require('../../admin/inc/global.php');
require('../../admin/inc/smarty.php');
require('../../admin/inc/lib.php');
require('../../admin/inc/class.adminclient.php');

if ($allow_webadmin == false)
	die('You must provide web administration service');

$retid = (double)microtime()*100000000;
$sessid = get_val('sessid');
$f_user = get_val('f_user');
$f_pass = get_val('f_pass');
$f_checkcode = get_val('f_checkcode');

$f_user = trim(strtolower($f_user));
$f_pass = trim($f_pass);
$f_checkcode = trim($f_checkcode);

if (strlen($f_user) == 0 || strlen($f_pass) == 0
	|| strlen($f_user) > 256 || strlen($f_pass) > 256){
	Header('Location: index.php?sessid='.$sessid.'&retid='.$retid); 
	exit; 
}

if (!preg_match('/^[0-9a-z]{32}$/i', $sessid))
	$sessid = '';

if ($sessid != '') {
	$sesshandle = New Session();
	
	$sesshandle->temp_folder = $SYSTEM_DIRECTORY['temporary'];
	$sesshandle->sessid = $sessid;
	$sesshandle->sesstype = SESSION_CODE;
	$sesshandle->timeout = $session_timeout;
	$session_value = $sesshandle->Load();
	$sesshandle->Kill();
}

if (!empty($errorpwd_retrytimes) && $_COOKIE['magicwinmail_admin_errorpwd_times'] >= $errorpwd_retrytimes) {
	Header('Location: badlogin.php?err=1&retid='.$retid);
	exit;
}

if ($errorpwd_checkcode != 0){
	$bCheckCode = true;
 	if ($errorpwd_checkcode == 2 && empty($_COOKIE['magicwinmail_admin_errorpwd_retry']))
		$bCheckCode = false;
		
	if ($bCheckCode) {
		$bCheckCodeError = false;
		if (is_array($session_value)) {
			$f_checkcode = trim($f_checkcode);
			if (strcasecmp($session_value['checkcode'], $f_checkcode) != 0) 
				$bCheckCodeError = true;
		}
		else {
			$bCheckCodeError = true;
		}
		
		if ($bCheckCodeError){
			$errorpwdtimes = $_COOKIE['magicwinmail_admin_errorpwd_times'];
			if (empty($errorpwdtimes))
				$errorpwdtimes = 1;
			else
				$errorpwdtimes++;
			
			my_setcookie('magicwinmail_admin_errorpwd_retry', '1', $errorpwd_shieldtime);
			my_setcookie('magicwinmail_admin_errorpwd_times', $errorpwdtimes, $errorpwd_shieldtime);
			
			Header('Location: badlogin.php?err=2&retid='.$retid); 
			exit;
		}
	}
}

if (substr($f_pass, 0, 10) == '{wm_crypt}')
	$f_pass = Crypt_Decode(substr($f_pass, 10));

$clientHandle = new admin_client($admin_server, $admin_port);

$ret = login_auth($clientHandle, $f_user, $f_pass);
if (is_array($ret) && $ret['session'] != '') {
	$sesshandle = New Session();
	$sesshandle->temp_folder = $SYSTEM_DIRECTORY['temporary'];
	$sesshandle->sesstype = SESSION_ADMIN;
	
	$sessid = $sesshandle->GenSessionID();
	if ($sessid == false){
		Header('Location: badlogin.php?retid='.$retid);
		exit;
	}

	$sesshandle->sessid = $sessid;
	$sesshandle->timeout = $session_timeout;
	$sesshandle->enable_cookies = true;
	$sesshandle->enable_ipcheck = $enable_ipcheck;
	
	$session_value = array();
	$session_value['session_id'] = $sessid;
	$session_value['session_token'] = $sesshandle->GenToken($sessid);
	
	$session_value['admin_auth'] = true;
	$session_value['admin_start'] = time();
	
	$session_value['lid'] = $lid;
	$session_value['session'] = $ret['session'];
	$session_value['maindomain'] = $ret['maindomain'];
	$session_value['adminuser'] = $f_user;
	$session_value['admintype'] = ($ret['usertype'] == 0) ? 'sup' : 'com';
	$session_value['adminrange'] = strtolower($ret['adminrange']);
	$session_value['mailmonitor'] = $ret['mailmonitor'];
	$session_value['mailsign'] = $ret['mailsign'];
	$session_value['mailarchive'] = $ret['mailarchive'];
	$session_value['patchversion'] = $ret['patchversion'];
	$session_value['newversion'] = $ret['newversion'];
	$session_value['visiturl'] = $ret['visiturl'];

	switch($reg_flagchar){
	default:
		$session_value['versiontype'] = 0;
		break;
	case '1':
	case 'A':
		$session_value['versiontype'] = 1;
		break;
	case '2':
	case 'B':
		$session_value['versiontype'] = 2;
		break;
	case '3':
	case 'C':
		$session_value['versiontype'] = 3;
		break;
	}
	
	$sesshandle->Save($session_value);

	$smarty->assign('SessID', $sessid);
	$smarty->assign('TokenID', md5(uniqid(microtime()).$sessid));

	my_setcookie('magicwinmail_admin_errorpwd_retry', '');
	my_setcookie('magicwinmail_admin_errorpwd_times', '');

	$smarty->display($selected_theme.'/login.htm');
}
else {
	$errorpwdtimes = $_COOKIE['magicwinmail_admin_errorpwd_times'];
	if (empty($errorpwdtimes))
		$errorpwdtimes = 1;
	else
		$errorpwdtimes++;
	
	my_setcookie('magicwinmail_admin_errorpwd_retry', '1', $errorpwd_shieldtime);
	my_setcookie('magicwinmail_admin_errorpwd_times', $errorpwdtimes, $errorpwd_shieldtime);

	Header('Location: badlogin.php?retid='.$retid);
}
?>